; the four pre-made ant warriors:
; 1) Spearhead
; 2) Random
; 3) Sense
; 4) Luck

(defun spearhead.ant () (let()
;based on predefined "spearhead.dir" (1 through 8)
(setq ant.local.x (+ ant.local.x (at x2 spearhead.dir)))
(setq ant.local.y (+ ant.local.y (at y2 spearhead.dir)))
)) ;end spearhead.ant

(defun random.ant () (let((r1 0))
(setq r1 (+ (random 8) 1))
(setq ant.local.x (+ ant.local.x (at x2 r1)))
(setq ant.local.y (+ ant.local.y (at y2 r1)))
)) ;end random.ant

(defun sniff.ant () (let((i 0)(success 0)(temp.x 0)(temp.y 0)(r1 0))
(loop for i from 1 to 8 do(let()
(setq r1 (+ (random 8) 1))
(setq temp.x (+ (at x2 i) ant.local.x))
(setq temp.y (+ (at y2 i) ant.local.y))
(if (< temp.x 1) (setq temp.x size.x) (if (> temp.x size.x) (setq temp.x 1)))
(if (< temp.y 1) (setq temp.y size.y) (if (> temp.y size.y) (setq temp.y 1)))
(if (= (at board temp.x temp.y) 1) (let()
(setq ant.local.x temp.x)
(setq ant.local.y temp.y)
(setq success 1)
)) ;end if
)) ;loop
(if (= success 0) (setq ant.local.x (+ ant.local.x 1)))
)) ;end sniff.ant

(defun lucky.ant () (let((i 0)(success 0)(temp.x 0)(temp.y 0)(r1 0))
(loop for i from 1 to 8 do(let()
(setq r1 (+ (random 8) 1))
(setq temp.x (+ (at x2 i) ant.local.x))
(setq temp.y (+ (at y2 i) ant.local.y))
(if (< temp.x 1) (setq temp.x size.x) (if (> temp.x size.x) (setq temp.x 1)))
(if (< temp.y 1) (setq temp.y size.y) (if (> temp.y size.y) (setq temp.y 1)))
(if (= (at board temp.x temp.y) 1) (let()
(setq ant.local.x temp.x)
(setq ant.local.y temp.y)
(setq success 1)
)) ;end if
)) ;loop
(if (= success 0) (let()
(setq r1 (+ (random 8) 1))
(setq ant.local.x (+ ant.local.x (at x2 r1)))
(setq ant.local.y (+ ant.local.y (at y2 r1)))
)) ;end if
)) ;end lucky.ant