(defun printout.ant (ant.index) (let((gene.index 0))
(print (+str "'This is the code of ant " (str$ ant.index) "."))
(loop for i from 1 to gene.amount do(let()
(setq gene.index (+ gene.index 1))
(pprint (printout.gene gene.index ant.index))
)) ;loop
)) ;end printout.ant

(defun printout.gene (gene.index ant.index) (let(
(i 0)(j 0)(number 1)(loc1 0)(loc2 0)(bit1 0)(goto1 0)(goto2 0)(stringtp "")(use.goto1)(use.goto2))
(setq number 1) (loop for i from 1 to lg.antstring.length do(let()
(setq loc1 (+ loc1 (* number (genestring.at ant.index gene.index i))))
(setq number (* number 2)) 
)) ;loop
(setq bit1 (genestring.at ant.index gene.index (+ lg.antstring.length 1)))
(setq j (+ lg.antstring.length 2))
(setq number 1) (loop for i from j to (+ lg.antstring.length j -1) do(let()
(setq loc2 (+ loc2 (* number (genestring.at ant.index gene.index i))))
(setq number (* number 2)) 
)) ;loop

(setq loc1 (mod loc1 antstring.length)) (if (= loc1 0) (setq loc1 antstring.length))
(setq a2 (- antstring.length min.bit -1))
(setq loc2 (mod loc2 a2)) (if (= loc2 0) (setq loc2 a2))
(setq loc2 (+ loc2 min.bit -2))
(setf (bit antstring loc2) (- 1 (bit antstring loc2)))


(setq use.goto1 (genestring.at ant.index gene.index (+ j lg.antstring.length)))
(setq j (+ 1 j lg.antstring.length))
(setq number 1) (loop for i from j to (+ lg.genestring.amount j -1) do(let()
(setq goto1 (+ goto1 (* number (genestring.at ant.index gene.index i))))
(setq number (* number 2)) 
)) ;next i
(setq use.goto2 (genestring.at ant.index gene.index (+ j lg.genestring.amount)))
(setq j (+ 1 j lg.genestring.amount))
(setq number 1) (loop for i from j to (+ lg.genestring.amount j -1) do(let()
(setq goto2 (+ goto2 (* number (genestring.at ant.index gene.index i))))
(setq number (* number 2)) 
)) ;next i

(setq goto1 (mod goto1 gene.amount)) (if (= goto1 0) (setq goto1 gene.amount))
(setq goto2 (mod goto2 gene.amount)) (if (= goto2 0) (setq goto2 gene.amount))

(setq stringtp (+str stringtp "gene" (str$ gene.index) ": IF bit(" (str$ loc1) ") = " (str$ bit1) " THEN"))
(setq stringtp (+str stringtp " toggle bit(" (str$ loc2) ")"))
(if (= use.goto1 1) (setq stringtp (+str stringtp ": GOTO gene" (str$ goto1))))
(if (= use.goto2 1) (let()
(setq stringtp (+str stringtp " ELSE GOTO gene" (str$ goto2)))
)) ;end if
stringtp
)) ;end printout.gene

(defun create.small.trail () (let() (setq size 0)
(setq scent (dim 'scent size.x size.y)) ; 0 to 15
(setq board.pic #(
".0.0."
".0..."
"00..."
".0.00"
"....0"
)) (setq board (load.trail.pic board.pic))
)) ;end create.small.trail

(defun create.santafe.trail () (let() (setq size 0)
(setq scent (dim 'scent size.x size.y)) ; 0 to 15
(setq board.pic #(
".000............................"
"...0............................"
"...0.....................000...."
"...0....................0....0.."
"...0....................0....0.."
"...0000.00000........00........."
"............0................0.."
"............0.......0..........."
"............0.......0..........."
"............0.......0........0.."
"....................0..........."
"............0..................."
"............0................0.."
"............0.......0..........."
"............0.......0.....000..."
".................0.....0........"
"................................"
"............0..................."
"............0...0.......0......."
"............0...0..........0...."
"............0...0..............."
"............0...0..............."
"............0.............0....."
"............0..........0........"
"...00..00000....0..............."
".0..............0..............."
".0..............0..............."
".0......0000000................."
".0.....0........................"
".......0........................"
"..0000.........................."
"................................"
)) (setq board (load.trail.pic board.pic))
)) ;end create.santafe.trail

(defun create.fashionable.trail () (let()
(setq scent (dim 'scent size.x size.y)) ; 0 to 15
(setq board.pic #(
"................................"
".0000..........................."
"....0..........................."
"....0..........................."
"00..0.......................0000"
"....0......................0...."
".....0.....................0...."
"....0.0....................0...."
"....0..0...................0...."
"....0...0..................0...."
"....0....0.................0...."
"....0.....000000000000.....0...."
"....0.....000000000000.....0...."
"....0.....000000000000.....0...."
"....0.....0000000000000000.0...."
"....0......................0...."
"....0.0000000000000000.....0...."
"....0.....000000000000.....0...."
"....0.....000000000000.....0...."
"....0.....000000000000.....0...."
"....0.................0....0...."
"....0..................0...0...."
"....0...................0..0...."
"....0....................0.0...."
"....0.....................0....."
"0000.......................0..00"
"...........................0...."
"...........................0...."
"...........................0...."
"...........................0...."
"...........................0000."
"................................"
)) (setq board (load.trail.pic board.pic))
)) ;end create.fashionable.trail

(defun count.pellets (temp.board) (let((pellets 0))
(loop for x from 1 to size.x do(let()
(loop for y from 1 to size.y do(let()
(if (= (at board x y) 1) (setq pellets (+ pellets 1)))
)) ;next y
)) ;next x
pellets
)) ;end count.pellets

(defun initialize.trace.board () (let()
(setq trace.stream (dim 'size.x size.y))
)) ;end initialize.trace.board

(defun add.to.trace.board (cur.match) (let()
(=a trace.stream size.x size.y cur.match)
)) ;end add.to.trace.board

(defun print.trace.board () (let()
(loop for y from 1 to size.y do(let()
(setq plist "")
(loop for x from 1 to size.x do(let()
(if (<> (at trace.stream x y) 0) (setq plist (+str plist "*"))
(let();else
(setq temp.num (at board x y)) (if (= temp.num 1) (setq plist (+str plist "0"))
);else
(if (= temp.num 1) (setq plist (+str plist ".")))
)) ;end ifs
)) ;loop
(pprint plist)
)) ;loop
)) ;print.trace.board


(defun load.trail.pic (temp.board.pic) (let((temp.board 0) (i 0) (x 0) (y 0))
(setq size.x (length (aref temp.board.pic 1)) size.y (car (array-dimensions temp.board.pic)))
(setq temp.board (dim 'temp.board size.x size.y))
(loop for x from 1 to size.x do(let()
(loop for y from 1 to size.y do(let()
(setq i (instr alphastring (mid$ (at temp.board.pic y) x)))
(if (<> i 0) (=a temp.board x y (* i -1))
(if (equalp (mid$ (at temp.board.pic y) x) "0") (=a temp.board x y 1)
)) ;end ifs
)) ;next y
)) ;next x
temp.board
)) ;end load.trail.pic

(defun print.board () (let((plist "") (temp.num 0))
(loop for y from 1 to size.y do(let()
(setq plist "")
(loop for x from 1 to size.x do(let()
(setq temp.num (at board x y))
(if (= temp.num 0) (setq plist (+str plist "."))
(if (= temp.num 1) (setq plist (+str plist "0"))
(if (< temp.num 0) (let()
(setq temp.num (mod (* -1 temp.num) 52))
(if (= temp.num 0) (setq temp.num 52))
(setq plist (+str plist (mid$ alphastring temp.num)))
)) ;end if
)) ;end ifs
)) ;loop
(pprint plist)
)) ;loop
)) ;end print.board

(defun disp.ant.scores () (let((cur.ant.type "")(cur.ant 0))
(loop for i from 1 to ant.amount do(let()
(setq cur.ant (at ant.type (at read.order i)))
(if (= cur.ant 0) (setq cur.ant.type "evo ant bot")
(if (= cur.ant 1) (setq cur.ant.type "random ant")
(if (= cur.ant 2) (setq cur.ant.type "spearhead ant")
(if (= cur.ant 3) (setq cur.ant.type "lucky ant")
(if (= cur.ant 4) (setq cur.ant.type "sniff ant")
))))) ;end ifs
(pprint (+str "Score of ant " (str$ i) ": " (str$ (at ant.score (at read.order i))) " food units! (" cur.ant.type")"))
)) ;next i
)) ;end disp.ant.scores

(defun print.results.matrix () (let((i 0) (tot.score 0) (x1 0)(y1 0) (adstr ""))
;(loop for i from 1 to ant.amount do(let()
;(setq tot.score (+ tot.score (at ant.score i)))
;)) ;next i
(loop for x1 from 1 to ant.amount do(let()
(setq adstr "") (loop for y1 from 1 to ant.amount do(let()
(setq adstr (+str adstr (str$ (at ant.score y1)) "/" (str$ (at ant.score x1)) " - ") )
)) ;next y1
(pprint (+str (str$ x1) ": " adstr))
)) ;next x1
)) ;end print.results.matrix

(defun get.blank.board () (let()
(setq board (g2 board.t))
(setq scent (dim 'scent size.x size.y)) ; 0 to 15
)) ;end get.blank.board
(defun g2 (temp.board2) (let()
(setq size.y (car (cdr (array-dimensions temp.board2))) size.x (car (array-dimensions temp.board2)))
(setq temp.board (dim 'temp.board size.x size.y))
(loop for x from 1 to size.x do(let()
(loop for y from 1 to size.y do(let()
(=a temp.board x y (at temp.board2 x y))
)) ;next y
)) ;next x
temp.board
)) ;end g2